/* commands-editor-row.c generated by valac 0.56.18, the Vala compiler
 * generated from commands-editor-row.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2025 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_COMMANDS_EDITOR_ROW (haguichi_commands_editor_row_get_type ())
#define HAGUICHI_COMMANDS_EDITOR_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR_ROW, HaguichiCommandsEditorRow))
#define HAGUICHI_COMMANDS_EDITOR_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_COMMANDS_EDITOR_ROW, HaguichiCommandsEditorRowClass))
#define HAGUICHI_IS_COMMANDS_EDITOR_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR_ROW))
#define HAGUICHI_IS_COMMANDS_EDITOR_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_COMMANDS_EDITOR_ROW))
#define HAGUICHI_COMMANDS_EDITOR_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR_ROW, HaguichiCommandsEditorRowClass))

typedef struct _HaguichiCommandsEditorRow HaguichiCommandsEditorRow;
typedef struct _HaguichiCommandsEditorRowClass HaguichiCommandsEditorRowClass;
typedef struct _HaguichiCommandsEditorRowPrivate HaguichiCommandsEditorRowPrivate;

#define HAGUICHI_TYPE_COMMANDS_EDITOR (haguichi_commands_editor_get_type ())
#define HAGUICHI_COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR, HaguichiCommandsEditor))
#define HAGUICHI_COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_COMMANDS_EDITOR, HaguichiCommandsEditorClass))
#define HAGUICHI_IS_COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR))
#define HAGUICHI_IS_COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_COMMANDS_EDITOR))
#define HAGUICHI_COMMANDS_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_COMMANDS_EDITOR, HaguichiCommandsEditorClass))

typedef struct _HaguichiCommandsEditor HaguichiCommandsEditor;
typedef struct _HaguichiCommandsEditorClass HaguichiCommandsEditorClass;
enum  {
	HAGUICHI_COMMANDS_EDITOR_ROW_0_PROPERTY,
	HAGUICHI_COMMANDS_EDITOR_ROW_NUM_PROPERTIES
};
static GParamSpec* haguichi_commands_editor_row_properties[HAGUICHI_COMMANDS_EDITOR_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _HaguichiCommandsEditorRow {
	AdwActionRow parent_instance;
	HaguichiCommandsEditorRowPrivate * priv;
	gboolean is_active;
	gboolean is_default;
	gchar* label;
	gchar* command_ipv4;
	gchar* command_ipv6;
	gchar* priority;
};

struct _HaguichiCommandsEditorRowClass {
	AdwActionRowClass parent_class;
};

struct _HaguichiCommandsEditorRowPrivate {
	HaguichiCommandsEditor* editor;
	GtkImage* drag_handle;
	GtkImage* default_emblem;
	GtkSwitch* command_switch;
};

static gint HaguichiCommandsEditorRow_private_offset;
static gpointer haguichi_commands_editor_row_parent_class = NULL;

VALA_EXTERN GType haguichi_commands_editor_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiCommandsEditorRow, g_object_unref)
VALA_EXTERN GType haguichi_commands_editor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiCommandsEditor, g_object_unref)
VALA_EXTERN HaguichiCommandsEditorRow* haguichi_commands_editor_row_new (HaguichiCommandsEditor* _editor,
                                                             gboolean _is_active,
                                                             gboolean _is_default,
                                                             const gchar* _label,
                                                             const gchar* _command_ipv4,
                                                             const gchar* _command_ipv6,
                                                             const gchar* _priority);
VALA_EXTERN HaguichiCommandsEditorRow* haguichi_commands_editor_row_construct (GType object_type,
                                                                   HaguichiCommandsEditor* _editor,
                                                                   gboolean _is_active,
                                                                   gboolean _is_default,
                                                                   const gchar* _label,
                                                                   const gchar* _command_ipv4,
                                                                   const gchar* _command_ipv6,
                                                                   const gchar* _priority);
static gboolean __lambda120_ (HaguichiCommandsEditorRow* self,
                       gboolean state);
VALA_EXTERN void haguichi_commands_editor_update_commands (HaguichiCommandsEditor* self);
static gboolean ___lambda120__gtk_switch_state_set (GtkSwitch* _sender,
                                             gboolean state,
                                             gpointer self);
VALA_EXTERN void haguichi_commands_editor_row_update (HaguichiCommandsEditorRow* self,
                                          const gchar* _label,
                                          const gchar* _command_ipv4,
                                          const gchar* _command_ipv6,
                                          const gchar* _priority);
VALA_EXTERN void haguichi_commands_editor_row_set_default (HaguichiCommandsEditorRow* self,
                                               gboolean _is_default);
VALA_EXTERN void haguichi_commands_editor_row_on_edit (HaguichiCommandsEditorRow* self);
VALA_EXTERN void haguichi_commands_editor_edit_command (HaguichiCommandsEditor* self,
                                            HaguichiCommandsEditorRow* row);
VALA_EXTERN void haguichi_commands_editor_row_on_move_up (HaguichiCommandsEditorRow* self);
VALA_EXTERN void haguichi_commands_editor_move_command (HaguichiCommandsEditor* self,
                                            HaguichiCommandsEditorRow* row,
                                            gint new_index);
VALA_EXTERN void haguichi_commands_editor_row_on_move_down (HaguichiCommandsEditorRow* self);
VALA_EXTERN void haguichi_commands_editor_row_on_set_deault (HaguichiCommandsEditorRow* self);
VALA_EXTERN void haguichi_commands_editor_set_default (HaguichiCommandsEditor* self,
                                           HaguichiCommandsEditorRow* default_row);
VALA_EXTERN void haguichi_commands_editor_row_on_remove (HaguichiCommandsEditorRow* self);
VALA_EXTERN void haguichi_commands_editor_remove_command (HaguichiCommandsEditor* self,
                                              HaguichiCommandsEditorRow* row);
VALA_EXTERN GdkContentProvider* haguichi_commands_editor_row_on_drag_prepare (HaguichiCommandsEditorRow* self);
static GdkContentProvider* _haguichi_commands_editor_row_on_drag_prepare_gtk_drag_source_prepare (GtkDragSource* _sender,
                                                                                           gdouble x,
                                                                                           gdouble y,
                                                                                           gpointer self);
VALA_EXTERN void haguichi_commands_editor_row_on_drag_begin (HaguichiCommandsEditorRow* self,
                                                 GdkDrag* drag);
static void _haguichi_commands_editor_row_on_drag_begin_gtk_drag_source_drag_begin (GtkDragSource* _sender,
                                                                             GdkDrag* drag,
                                                                             gpointer self);
VALA_EXTERN gboolean haguichi_commands_editor_row_on_drop (HaguichiCommandsEditorRow* self,
                                               GtkDropTarget* target,
                                               GValue* val,
                                               gdouble x,
                                               gdouble y);
static gboolean _haguichi_commands_editor_row_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                                     GValue* value,
                                                                     gdouble x,
                                                                     gdouble y,
                                                                     gpointer self);
VALA_EXTERN gchar* haguichi_command_replace_variables (gchar* command,
                                           const gchar* address,
                                           const gchar* nick,
                                           const gchar* id);
static GObject * haguichi_commands_editor_row_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
VALA_EXTERN gchar* haguichi_utils_get_available_theme_icon (gchar** icon_names,
                                                gint icon_names_length1);
static void haguichi_commands_editor_row_finalize (GObject * obj);
static GType haguichi_commands_editor_row_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
haguichi_commands_editor_row_get_instance_private (HaguichiCommandsEditorRow* self)
{
	return G_STRUCT_MEMBER_P (self, HaguichiCommandsEditorRow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../src/widgets/commands-editor-row.vala"
	return self ? g_object_ref (self) : NULL;
#line 197 "commands-editor-row.c"
}

static gboolean
__lambda120_ (HaguichiCommandsEditorRow* self,
              gboolean state)
{
	HaguichiCommandsEditor* _tmp0_;
	gboolean result;
#line 59 "../src/widgets/commands-editor-row.vala"
	self->is_active = state;
#line 60 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 60 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_update_commands (_tmp0_);
#line 61 "../src/widgets/commands-editor-row.vala"
	result = FALSE;
#line 61 "../src/widgets/commands-editor-row.vala"
	return result;
#line 216 "commands-editor-row.c"
}

static gboolean
___lambda120__gtk_switch_state_set (GtkSwitch* _sender,
                                    gboolean state,
                                    gpointer self)
{
	gboolean result;
	result = __lambda120_ ((HaguichiCommandsEditorRow*) self, state);
#line 58 "../src/widgets/commands-editor-row.vala"
	return result;
#line 228 "commands-editor-row.c"
}

HaguichiCommandsEditorRow*
haguichi_commands_editor_row_construct (GType object_type,
                                        HaguichiCommandsEditor* _editor,
                                        gboolean _is_active,
                                        gboolean _is_default,
                                        const gchar* _label,
                                        const gchar* _command_ipv4,
                                        const gchar* _command_ipv6,
                                        const gchar* _priority)
{
	HaguichiCommandsEditorRow * self = NULL;
	HaguichiCommandsEditor* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
#line 52 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_editor != NULL, NULL);
#line 52 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_label != NULL, NULL);
#line 52 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_command_ipv4 != NULL, NULL);
#line 52 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_command_ipv6 != NULL, NULL);
#line 52 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (_priority != NULL, NULL);
#line 52 "../src/widgets/commands-editor-row.vala"
	self = (HaguichiCommandsEditorRow*) g_object_new (object_type, NULL);
#line 53 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = _g_object_ref0 (_editor);
#line 53 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->editor);
#line 53 "../src/widgets/commands-editor-row.vala"
	self->priv->editor = _tmp0_;
#line 54 "../src/widgets/commands-editor-row.vala"
	self->is_active = _is_active;
#line 55 "../src/widgets/commands-editor-row.vala"
	self->is_default = _is_default;
#line 57 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = self->priv->command_switch;
#line 57 "../src/widgets/commands-editor-row.vala"
	gtk_switch_set_active (_tmp1_, self->is_active);
#line 58 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = self->priv->command_switch;
#line 58 "../src/widgets/commands-editor-row.vala"
	g_signal_connect_object (_tmp2_, "state-set", (GCallback) ___lambda120__gtk_switch_state_set, self, 0);
#line 64 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_row_update (self, _label, _command_ipv4, _command_ipv6, _priority);
#line 65 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_row_set_default (self, self->is_default);
#line 52 "../src/widgets/commands-editor-row.vala"
	return self;
#line 281 "commands-editor-row.c"
}

HaguichiCommandsEditorRow*
haguichi_commands_editor_row_new (HaguichiCommandsEditor* _editor,
                                  gboolean _is_active,
                                  gboolean _is_default,
                                  const gchar* _label,
                                  const gchar* _command_ipv4,
                                  const gchar* _command_ipv6,
                                  const gchar* _priority)
{
#line 52 "../src/widgets/commands-editor-row.vala"
	return haguichi_commands_editor_row_construct (HAGUICHI_TYPE_COMMANDS_EDITOR_ROW, _editor, _is_active, _is_default, _label, _command_ipv4, _command_ipv6, _priority);
#line 295 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_on_edit (HaguichiCommandsEditorRow* self)
{
	HaguichiCommandsEditor* _tmp0_;
#line 68 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 69 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_edit_command (_tmp0_, self);
#line 308 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_on_move_up (HaguichiCommandsEditorRow* self)
{
	HaguichiCommandsEditor* _tmp0_;
#line 72 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 73 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_move_command (_tmp0_, self, gtk_list_box_row_get_index ((GtkListBoxRow*) self) - 1);
#line 321 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_on_move_down (HaguichiCommandsEditorRow* self)
{
	HaguichiCommandsEditor* _tmp0_;
#line 76 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 77 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_move_command (_tmp0_, self, gtk_list_box_row_get_index ((GtkListBoxRow*) self) + 1);
#line 334 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_on_set_deault (HaguichiCommandsEditorRow* self)
{
	HaguichiCommandsEditor* _tmp0_;
#line 80 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 81 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_set_default (_tmp0_, self);
#line 347 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_on_remove (HaguichiCommandsEditorRow* self)
{
	HaguichiCommandsEditor* _tmp0_;
#line 84 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 85 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_remove_command (_tmp0_, self);
#line 360 "commands-editor-row.c"
}

GdkContentProvider*
haguichi_commands_editor_row_on_drag_prepare (HaguichiCommandsEditorRow* self)
{
	GValue _tmp0_ = {0};
	GdkContentProvider* _tmp1_;
	GdkContentProvider* _tmp2_;
	GdkContentProvider* result;
#line 89 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/widgets/commands-editor-row.vala"
	g_value_init (&_tmp0_, HAGUICHI_TYPE_COMMANDS_EDITOR_ROW);
#line 90 "../src/widgets/commands-editor-row.vala"
	g_value_set_object (&_tmp0_, self);
#line 90 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = gdk_content_provider_new_for_value (&_tmp0_);
#line 90 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = _tmp1_;
#line 90 "../src/widgets/commands-editor-row.vala"
	G_IS_VALUE (&_tmp0_) ? (g_value_unset (&_tmp0_), NULL) : NULL;
#line 90 "../src/widgets/commands-editor-row.vala"
	result = _tmp2_;
#line 90 "../src/widgets/commands-editor-row.vala"
	return result;
#line 386 "commands-editor-row.c"
}

static GdkContentProvider*
_haguichi_commands_editor_row_on_drag_prepare_gtk_drag_source_prepare (GtkDragSource* _sender,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self)
{
	GdkContentProvider* result;
	result = haguichi_commands_editor_row_on_drag_prepare ((HaguichiCommandsEditorRow*) self);
#line 15 "../src/widgets/commands-editor-row.vala"
	return result;
#line 399 "commands-editor-row.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 421 "commands-editor-row.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 425 "commands-editor-row.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 431 "commands-editor-row.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 435 "commands-editor-row.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 439 "commands-editor-row.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 447 "commands-editor-row.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 475 "commands-editor-row.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 484 "commands-editor-row.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 498 "commands-editor-row.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 507 "commands-editor-row.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 521 "commands-editor-row.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 530 "commands-editor-row.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 539 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_on_drag_begin (HaguichiCommandsEditorRow* self,
                                            GdkDrag* drag)
{
	HaguichiCommandsEditorRow* drag_row = NULL;
	HaguichiCommandsEditor* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	HaguichiCommandsEditorRow* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkListBox* drag_widget = NULL;
	GtkListBox* _tmp9_;
	GtkDragIcon* icon = NULL;
	GtkWidget* _tmp10_;
	GtkDragIcon* _tmp11_;
#line 94 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (drag != NULL);
#line 95 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->editor;
#line 95 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = self->label;
#line 95 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = self->command_ipv4;
#line 95 "../src/widgets/commands-editor-row.vala"
	_tmp3_ = self->command_ipv6;
#line 95 "../src/widgets/commands-editor-row.vala"
	_tmp4_ = self->priority;
#line 95 "../src/widgets/commands-editor-row.vala"
	_tmp5_ = haguichi_commands_editor_row_new (_tmp0_, self->is_active, self->is_default, _tmp1_, _tmp2_, _tmp3_, _tmp4_);
#line 95 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp5_);
#line 95 "../src/widgets/commands-editor-row.vala"
	drag_row = _tmp5_;
#line 98 "../src/widgets/commands-editor-row.vala"
	adw_preferences_row_set_use_underline ((AdwPreferencesRow*) drag_row, FALSE);
#line 99 "../src/widgets/commands-editor-row.vala"
	_tmp6_ = self->label;
#line 99 "../src/widgets/commands-editor-row.vala"
	_tmp7_ = string_replace (_tmp6_, "_", "");
#line 99 "../src/widgets/commands-editor-row.vala"
	_tmp8_ = _tmp7_;
#line 99 "../src/widgets/commands-editor-row.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) drag_row, _tmp8_);
#line 99 "../src/widgets/commands-editor-row.vala"
	_g_free0 (_tmp8_);
#line 101 "../src/widgets/commands-editor-row.vala"
	_tmp9_ = (GtkListBox*) gtk_list_box_new ();
#line 101 "../src/widgets/commands-editor-row.vala"
	g_object_ref_sink (_tmp9_);
#line 101 "../src/widgets/commands-editor-row.vala"
	drag_widget = _tmp9_;
#line 102 "../src/widgets/commands-editor-row.vala"
	gtk_widget_set_size_request ((GtkWidget*) drag_widget, gtk_widget_get_width ((GtkWidget*) self), gtk_widget_get_height ((GtkWidget*) self));
#line 107 "../src/widgets/commands-editor-row.vala"
	gtk_list_box_append (drag_widget, (GtkWidget*) drag_row);
#line 108 "../src/widgets/commands-editor-row.vala"
	gtk_list_box_drag_highlight_row (drag_widget, (GtkListBoxRow*) drag_row);
#line 110 "../src/widgets/commands-editor-row.vala"
	_tmp10_ = gtk_drag_icon_get_for_drag (drag);
#line 110 "../src/widgets/commands-editor-row.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_drag_icon_get_type ()) ? ((GtkDragIcon*) _tmp10_) : NULL);
#line 110 "../src/widgets/commands-editor-row.vala"
	icon = _tmp11_;
#line 111 "../src/widgets/commands-editor-row.vala"
	gtk_drag_icon_set_child (icon, (GtkWidget*) drag_widget);
#line 94 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (icon);
#line 94 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (drag_widget);
#line 94 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (drag_row);
#line 619 "commands-editor-row.c"
}

static void
_haguichi_commands_editor_row_on_drag_begin_gtk_drag_source_drag_begin (GtkDragSource* _sender,
                                                                        GdkDrag* drag,
                                                                        gpointer self)
{
#line 15 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_row_on_drag_begin ((HaguichiCommandsEditorRow*) self, drag);
#line 629 "commands-editor-row.c"
}

gboolean
haguichi_commands_editor_row_on_drop (HaguichiCommandsEditorRow* self,
                                      GtkDropTarget* target,
                                      GValue* val,
                                      gdouble x,
                                      gdouble y)
{
	HaguichiCommandsEditorRow* row = NULL;
	GValue _tmp0_;
	HaguichiCommandsEditorRow* _tmp1_;
	HaguichiCommandsEditorRow* _tmp2_;
	gboolean result;
#line 115 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 115 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 115 "../src/widgets/commands-editor-row.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 116 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = *val;
#line 116 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = _g_object_ref0 (g_value_get_object (&_tmp0_));
#line 116 "../src/widgets/commands-editor-row.vala"
	row = _tmp1_;
#line 118 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = row;
#line 118 "../src/widgets/commands-editor-row.vala"
	if (_tmp2_ == self) {
#line 120 "../src/widgets/commands-editor-row.vala"
		result = FALSE;
#line 120 "../src/widgets/commands-editor-row.vala"
		_g_object_unref0 (row);
#line 120 "../src/widgets/commands-editor-row.vala"
		return result;
#line 666 "commands-editor-row.c"
	} else {
		HaguichiCommandsEditor* _tmp3_;
		HaguichiCommandsEditorRow* _tmp4_;
#line 123 "../src/widgets/commands-editor-row.vala"
		_tmp3_ = self->priv->editor;
#line 123 "../src/widgets/commands-editor-row.vala"
		_tmp4_ = row;
#line 123 "../src/widgets/commands-editor-row.vala"
		haguichi_commands_editor_move_command (_tmp3_, _tmp4_, gtk_list_box_row_get_index ((GtkListBoxRow*) self));
#line 124 "../src/widgets/commands-editor-row.vala"
		result = TRUE;
#line 124 "../src/widgets/commands-editor-row.vala"
		_g_object_unref0 (row);
#line 124 "../src/widgets/commands-editor-row.vala"
		return result;
#line 682 "commands-editor-row.c"
	}
}

static gboolean
_haguichi_commands_editor_row_on_drop_gtk_drop_target_drop (GtkDropTarget* _sender,
                                                            GValue* value,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
	gboolean result;
	result = haguichi_commands_editor_row_on_drop ((HaguichiCommandsEditorRow*) self, _sender, value, x, y);
#line 15 "../src/widgets/commands-editor-row.vala"
	return result;
#line 697 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_update (HaguichiCommandsEditorRow* self,
                                     const gchar* _label,
                                     const gchar* _command_ipv4,
                                     const gchar* _command_ipv6,
                                     const gchar* _priority)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* command = NULL;
	gchar* _tmp8_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	gchar* address = NULL;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 128 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_label != NULL);
#line 128 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_command_ipv4 != NULL);
#line 128 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_command_ipv6 != NULL);
#line 128 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (_priority != NULL);
#line 129 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = g_strdup (_label);
#line 129 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->label);
#line 129 "../src/widgets/commands-editor-row.vala"
	self->label = _tmp0_;
#line 130 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = g_strdup (_command_ipv4);
#line 130 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv4);
#line 130 "../src/widgets/commands-editor-row.vala"
	self->command_ipv4 = _tmp1_;
#line 131 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = g_strdup (_command_ipv6);
#line 131 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv6);
#line 131 "../src/widgets/commands-editor-row.vala"
	self->command_ipv6 = _tmp2_;
#line 132 "../src/widgets/commands-editor-row.vala"
	_tmp3_ = g_strdup (_priority);
#line 132 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->priority);
#line 132 "../src/widgets/commands-editor-row.vala"
	self->priority = _tmp3_;
#line 134 "../src/widgets/commands-editor-row.vala"
	_tmp5_ = self->priority;
#line 134 "../src/widgets/commands-editor-row.vala"
	if (g_strcmp0 (_tmp5_, "IPv6") == 0) {
#line 761 "commands-editor-row.c"
		const gchar* _tmp6_;
#line 134 "../src/widgets/commands-editor-row.vala"
		_tmp6_ = self->command_ipv6;
#line 134 "../src/widgets/commands-editor-row.vala"
		_tmp4_ = _tmp6_;
#line 767 "commands-editor-row.c"
	} else {
		const gchar* _tmp7_;
#line 134 "../src/widgets/commands-editor-row.vala"
		_tmp7_ = self->command_ipv4;
#line 134 "../src/widgets/commands-editor-row.vala"
		_tmp4_ = _tmp7_;
#line 774 "commands-editor-row.c"
	}
#line 134 "../src/widgets/commands-editor-row.vala"
	_tmp8_ = g_strdup (_tmp4_);
#line 134 "../src/widgets/commands-editor-row.vala"
	command = _tmp8_;
#line 135 "../src/widgets/commands-editor-row.vala"
	_tmp10_ = self->priority;
#line 135 "../src/widgets/commands-editor-row.vala"
	if (g_strcmp0 (_tmp10_, "IPv6") == 0) {
#line 135 "../src/widgets/commands-editor-row.vala"
		_tmp9_ = "2620:9b::56d:f78e";
#line 786 "commands-editor-row.c"
	} else {
#line 135 "../src/widgets/commands-editor-row.vala"
		_tmp9_ = "25.123.456.78";
#line 790 "commands-editor-row.c"
	}
#line 135 "../src/widgets/commands-editor-row.vala"
	_tmp11_ = g_strdup (_tmp9_);
#line 135 "../src/widgets/commands-editor-row.vala"
	address = _tmp11_;
#line 137 "../src/widgets/commands-editor-row.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) self, _ (_label));
#line 138 "../src/widgets/commands-editor-row.vala"
	_tmp12_ = command;
#line 138 "../src/widgets/commands-editor-row.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 138 "../src/widgets/commands-editor-row.vala"
	_tmp14_ = haguichi_command_replace_variables (_tmp13_, address, "Nick", "090-123-456");
#line 138 "../src/widgets/commands-editor-row.vala"
	_tmp15_ = _tmp14_;
#line 138 "../src/widgets/commands-editor-row.vala"
	adw_action_row_set_subtitle ((AdwActionRow*) self, _tmp15_);
#line 138 "../src/widgets/commands-editor-row.vala"
	_g_free0 (_tmp15_);
#line 128 "../src/widgets/commands-editor-row.vala"
	_g_free0 (address);
#line 128 "../src/widgets/commands-editor-row.vala"
	_g_free0 (command);
#line 814 "commands-editor-row.c"
}

void
haguichi_commands_editor_row_set_default (HaguichiCommandsEditorRow* self,
                                          gboolean _is_default)
{
	GtkImage* _tmp0_;
#line 141 "../src/widgets/commands-editor-row.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/widgets/commands-editor-row.vala"
	self->is_default = _is_default;
#line 143 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->default_emblem;
#line 143 "../src/widgets/commands-editor-row.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, self->is_default);
#line 830 "commands-editor-row.c"
}

static GObject *
haguichi_commands_editor_row_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HaguichiCommandsEditorRow * self;
	GtkImage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkImage* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 32 "../src/widgets/commands-editor-row.vala"
	parent_class = G_OBJECT_CLASS (haguichi_commands_editor_row_parent_class);
#line 32 "../src/widgets/commands-editor-row.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../src/widgets/commands-editor-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_COMMANDS_EDITOR_ROW, HaguichiCommandsEditorRow);
#line 33 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "row.edit", NULL, (GtkWidgetActionActivateFunc) haguichi_commands_editor_row_on_edit);
#line 34 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "row.move-up", NULL, (GtkWidgetActionActivateFunc) haguichi_commands_editor_row_on_move_up);
#line 35 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "row.move-down", NULL, (GtkWidgetActionActivateFunc) haguichi_commands_editor_row_on_move_down);
#line 36 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "row.set-default", NULL, (GtkWidgetActionActivateFunc) haguichi_commands_editor_row_on_set_deault);
#line 37 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "row.remove", NULL, (GtkWidgetActionActivateFunc) haguichi_commands_editor_row_on_remove);
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp0_ = self->priv->drag_handle;
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp1_ = g_strdup ("list-drag-handle-symbolic");
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp2_ = g_strdup ("drag-handle-symbolic");
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp3_ = g_new0 (gchar*, 2 + 1);
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp3_[0] = _tmp1_;
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp3_[1] = _tmp2_;
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp4_ = _tmp3_;
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp4__length1 = 2;
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp5_ = haguichi_utils_get_available_theme_icon (_tmp4_, (gint) 2);
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp6_ = _tmp5_;
#line 39 "../src/widgets/commands-editor-row.vala"
	g_object_set (_tmp0_, "icon-name", _tmp6_, NULL);
#line 39 "../src/widgets/commands-editor-row.vala"
	_g_free0 (_tmp6_);
#line 39 "../src/widgets/commands-editor-row.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp7_ = self->priv->default_emblem;
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp8_ = g_strdup ("emblem-default-symbolic");
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp9_ = g_strdup ("emblem-ok-symbolic");
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp10_ = g_strdup ("object-select-symbolic");
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp11_ = g_strdup ("selection-mode-symbolic");
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp12_ = g_new0 (gchar*, 4 + 1);
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp12_[0] = _tmp8_;
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp12_[1] = _tmp9_;
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp12_[2] = _tmp10_;
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp12_[3] = _tmp11_;
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp13_ = _tmp12_;
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp13__length1 = 4;
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp14_ = haguichi_utils_get_available_theme_icon (_tmp13_, (gint) 4);
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp15_ = _tmp14_;
#line 44 "../src/widgets/commands-editor-row.vala"
	g_object_set (_tmp7_, "icon-name", _tmp15_, NULL);
#line 44 "../src/widgets/commands-editor-row.vala"
	_g_free0 (_tmp15_);
#line 44 "../src/widgets/commands-editor-row.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 32 "../src/widgets/commands-editor-row.vala"
	return obj;
#line 937 "commands-editor-row.c"
}

static void
haguichi_commands_editor_row_class_init (HaguichiCommandsEditorRowClass * klass,
                                         gpointer klass_data)
{
#line 15 "../src/widgets/commands-editor-row.vala"
	haguichi_commands_editor_row_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/widgets/commands-editor-row.vala"
	g_type_class_adjust_private_offset (klass, &HaguichiCommandsEditorRow_private_offset);
#line 15 "../src/widgets/commands-editor-row.vala"
	G_OBJECT_CLASS (klass)->constructor = haguichi_commands_editor_row_constructor;
#line 15 "../src/widgets/commands-editor-row.vala"
	G_OBJECT_CLASS (klass)->finalize = haguichi_commands_editor_row_finalize;
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/ztefn/haguichi/ui/widgets/commands-editor-row.ui");
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "drag_handle", FALSE, HaguichiCommandsEditorRow_private_offset + G_STRUCT_OFFSET (HaguichiCommandsEditorRowPrivate, drag_handle));
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "default_emblem", FALSE, HaguichiCommandsEditorRow_private_offset + G_STRUCT_OFFSET (HaguichiCommandsEditorRowPrivate, default_emblem));
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "command_switch", FALSE, HaguichiCommandsEditorRow_private_offset + G_STRUCT_OFFSET (HaguichiCommandsEditorRowPrivate, command_switch));
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_drag_prepare", G_CALLBACK(_haguichi_commands_editor_row_on_drag_prepare_gtk_drag_source_prepare));
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_drag_begin", G_CALLBACK(_haguichi_commands_editor_row_on_drag_begin_gtk_drag_source_drag_begin));
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_drop", G_CALLBACK(_haguichi_commands_editor_row_on_drop_gtk_drop_target_drop));
#line 966 "commands-editor-row.c"
}

static void
haguichi_commands_editor_row_instance_init (HaguichiCommandsEditorRow * self,
                                            gpointer klass)
{
#line 15 "../src/widgets/commands-editor-row.vala"
	self->priv = haguichi_commands_editor_row_get_instance_private (self);
#line 15 "../src/widgets/commands-editor-row.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 977 "commands-editor-row.c"
}

static void
haguichi_commands_editor_row_finalize (GObject * obj)
{
	HaguichiCommandsEditorRow * self;
#line 15 "../src/widgets/commands-editor-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_COMMANDS_EDITOR_ROW, HaguichiCommandsEditorRow);
#line 16 "../src/widgets/commands-editor-row.vala"
	_g_object_unref0 (self->priv->editor);
#line 20 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->label);
#line 21 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv4);
#line 22 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->command_ipv6);
#line 23 "../src/widgets/commands-editor-row.vala"
	_g_free0 (self->priority);
#line 15 "../src/widgets/commands-editor-row.vala"
	G_OBJECT_CLASS (haguichi_commands_editor_row_parent_class)->finalize (obj);
#line 998 "commands-editor-row.c"
}

static GType
haguichi_commands_editor_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiCommandsEditorRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_commands_editor_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiCommandsEditorRow), 0, (GInstanceInitFunc) haguichi_commands_editor_row_instance_init, NULL };
	GType haguichi_commands_editor_row_type_id;
	haguichi_commands_editor_row_type_id = g_type_register_static (adw_action_row_get_type (), "HaguichiCommandsEditorRow", &g_define_type_info, 0);
	HaguichiCommandsEditorRow_private_offset = g_type_add_instance_private (haguichi_commands_editor_row_type_id, sizeof (HaguichiCommandsEditorRowPrivate));
	return haguichi_commands_editor_row_type_id;
}

GType
haguichi_commands_editor_row_get_type (void)
{
	static volatile gsize haguichi_commands_editor_row_type_id__once = 0;
	if (g_once_init_enter (&haguichi_commands_editor_row_type_id__once)) {
		GType haguichi_commands_editor_row_type_id;
		haguichi_commands_editor_row_type_id = haguichi_commands_editor_row_get_type_once ();
		g_once_init_leave (&haguichi_commands_editor_row_type_id__once, haguichi_commands_editor_row_type_id);
	}
	return haguichi_commands_editor_row_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

